using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Imaging;

namespace WindowsApplication9
{
	public partial class Form1 : Form
	{
		TestClass m_Test = new TestClass();

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			Binding b = new Binding("Image", this.m_Test, "Pic", true, DataSourceUpdateMode.OnValidation);
			b.Format += new ConvertEventHandler(b_Format);
			b.Parse += new ConvertEventHandler(b_Parse); 
			this.pictureBox1.DataBindings.Add(b);
			
		}

		void b_Parse(object sender, ConvertEventArgs e)
		{
			// ja nisam uspeo da izazovem ovaj dogadjaj kontrole PictureBox, 
			// ali bi u ovom metodu trebalo da se obavi smestanje podataka 
			// sa PB u objekat. Moguce je da kontrola nema OnPropertyChanged("Image") 
			// dogadjaj implementiran

			if (e.DesiredType.Name == "Image")
			{
				Image im = e.Value as Image;
				if (im != null)
				{
					MemoryStream mem = new MemoryStream();
					im.Save(mem, im.RawFormat);
					byte[] b = new byte[mem.Length];
					mem.Write(b, 0, b.Length);
					// b[] mozes da koristis za dalju obradu,
					// 
				}
			}
		}

		void b_Format(object sender, ConvertEventArgs e)
		{
			if (e.DesiredType.Name == "Image")
			{
				if (e.Value == null)
				{
					Bitmap bmp = new Bitmap(1, 1);
					e.Value = (Image)bmp;
				}
				else
				{ // 
					using (MemoryStream mem = new MemoryStream(e.Value as byte[]))
					{
						e.Value = Image.FromStream(mem);
					}
				}
			}
		}

		
		private void button1_Click(object sender, EventArgs e)
		{
			if (openFileDialog1.ShowDialog() != DialogResult.Cancel)
			{
				Image im = Image.FromFile(openFileDialog1.FileName);
				using (MemoryStream mem = new MemoryStream())
				{
					im.Save(mem, im.RawFormat);
					this.m_Test.Pic = mem.ToArray();
				}

				//this.pictureBox1.Image = Image.FromFile(openFileDialog1.FileName);
			}
		}

		class TestClass : System.ComponentModel.INotifyPropertyChanged 
		{
			//private Image m_Image = null;
			private byte[] m_Image = null;

			public byte[] Pic
			{
				set
				{
					this.m_Image = value;
					if (PropertyChanged != null)
					{
						this.PropertyChanged(this, new PropertyChangedEventArgs("Pic"));
					}
				}
				get { return this.m_Image; }
			}
			//public Image Pic
			//{
			//  set 
			//  { 
			//    this.m_Image = value;
			//    if (PropertyChanged != null)
			//    {
			//      this.PropertyChanged(this, new PropertyChangedEventArgs("Pic"));
			//    }
			//  }
			//  get { return this.m_Image; }
			//}

			#region INotifyPropertyChanged Members

			public event PropertyChangedEventHandler PropertyChanged;

			#endregion
		}

		

	
	}
}